<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="classVertexP-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__core.html">Core Classes</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class and add messaging capabilities This class is inherited by customized classes for different graph algorithms. It is a template class that is parameterized by the following parameters  
 <a href="classVertexP.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersPregelVertex_8hpp_source.html">tiglContainersPregelVertex.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classVertexP.png" usemap="#VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;_map" alt=""/>
  <map id="VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;_map" name="VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;_map">
<area href="classvertex.html" title="core vertex class that contains all the vertex data and defines all vertex mutations It is a template..." alt="vertex&lt; DataType, AlgDataType, EdgeType, IdType &gt;" shape="rect" coords="0, 0, 471, 24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a073ad0f9e1d21754499bde31ad5b4e8f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#a073ad0f9e1d21754499bde31ad5b4e8f">VertexP</a> (IdType key, bool noMessageFlag=false, bool inFlagReactivate=true)</td></tr>
<tr class="memdesc:a073ad0f9e1d21754499bde31ad5b4e8f"><td class="mdescLeft">&#160;</td><td class="mdescRight">constructor setting parameters and callign the constructor of the base class  <a href="#a073ad0f9e1d21754499bde31ad5b4e8f">More...</a><br /></td></tr>
<tr class="separator:a073ad0f9e1d21754499bde31ad5b4e8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7bc73775db8b49faad7f1f1941febda"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab7bc73775db8b49faad7f1f1941febda"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#ab7bc73775db8b49faad7f1f1941febda">vote_to_halt</a> ()</td></tr>
<tr class="memdesc:ab7bc73775db8b49faad7f1f1941febda"><td class="mdescLeft">&#160;</td><td class="mdescRight">disable the node <br /></td></tr>
<tr class="separator:ab7bc73775db8b49faad7f1f1941febda"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a54c31bf57dbd684e6f42fbf66283a87e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a54c31bf57dbd684e6f42fbf66283a87e"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#a54c31bf57dbd684e6f42fbf66283a87e">isActive</a> ()</td></tr>
<tr class="memdesc:a54c31bf57dbd684e6f42fbf66283a87e"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if the node is active <br /></td></tr>
<tr class="separator:a54c31bf57dbd684e6f42fbf66283a87e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa581f96dfa435abd1af0c0736e3c6d4a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa581f96dfa435abd1af0c0736e3c6d4a"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#aa581f96dfa435abd1af0c0736e3c6d4a">isActiveWithNoMessage</a> ()</td></tr>
<tr class="memdesc:aa581f96dfa435abd1af0c0736e3c6d4a"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if the vertex stays active even without messages <br /></td></tr>
<tr class="separator:aa581f96dfa435abd1af0c0736e3c6d4a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37ff8508671d66188fff4e91f9547dcd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a37ff8508671d66188fff4e91f9547dcd"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#a37ff8508671d66188fff4e91f9547dcd">canReactivate</a> ()</td></tr>
<tr class="memdesc:a37ff8508671d66188fff4e91f9547dcd"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if the vertex can be reactivated by new messages <br /></td></tr>
<tr class="separator:a37ff8508671d66188fff4e91f9547dcd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a814726329f65bb0db086b41e521e0d80"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a814726329f65bb0db086b41e521e0d80"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#a814726329f65bb0db086b41e521e0d80">activate</a> ()</td></tr>
<tr class="memdesc:a814726329f65bb0db086b41e521e0d80"><td class="mdescLeft">&#160;</td><td class="mdescRight">activating the node <br /></td></tr>
<tr class="separator:a814726329f65bb0db086b41e521e0d80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7ed5eb0c1d2c351bdc086d42a2684c7"><td class="memItemLeft" align="right" valign="top">virtual uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#aa7ed5eb0c1d2c351bdc086d42a2684c7">compute</a> (MESSAGE_BUF_TYPE *pIn, LOCAL_MESSAGE_BUF *pOut, uint32 numMessages)</td></tr>
<tr class="memdesc:aa7ed5eb0c1d2c351bdc086d42a2684c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual core compute function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms  <a href="#aa7ed5eb0c1d2c351bdc086d42a2684c7">More...</a><br /></td></tr>
<tr class="separator:aa7ed5eb0c1d2c351bdc086d42a2684c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9caab616ae90c7f0c6af36953f3f441"><td class="memItemLeft" align="right" valign="top">virtual uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#ad9caab616ae90c7f0c6af36953f3f441">init</a> (INIT_TYPE *initParams, LOCAL_MESSAGE_BUF *pOut)</td></tr>
<tr class="memdesc:ad9caab616ae90c7f0c6af36953f3f441"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual core init function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms  <a href="#ad9caab616ae90c7f0c6af36953f3f441">More...</a><br /></td></tr>
<tr class="separator:ad9caab616ae90c7f0c6af36953f3f441"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classvertex"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classvertex')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classvertex.html">vertex&lt; DataType, AlgDataType, EdgeType, IdType &gt;</a></td></tr>
<tr class="memitem:acc18610f997b882cc447871819f3a7f0 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#acc18610f997b882cc447871819f3a7f0">vertex</a> (IdType key)</td></tr>
<tr class="memdesc:acc18610f997b882cc447871819f3a7f0 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">constructor assign the id  <a href="#acc18610f997b882cc447871819f3a7f0">More...</a><br /></td></tr>
<tr class="separator:acc18610f997b882cc447871819f3a7f0 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed3e52a8b910fb69eb2fb3b5dc355804 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#aed3e52a8b910fb69eb2fb3b5dc355804">add_edge</a> (EdgeType &amp;x)</td></tr>
<tr class="memdesc:aed3e52a8b910fb69eb2fb3b5dc355804 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding output edge  <a href="#aed3e52a8b910fb69eb2fb3b5dc355804">More...</a><br /></td></tr>
<tr class="separator:aed3e52a8b910fb69eb2fb3b5dc355804 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cee60eb3a2149e2c0c8171d1948d9b4 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a7cee60eb3a2149e2c0c8171d1948d9b4">add_edge</a> (ID_TYPE &amp;target)</td></tr>
<tr class="memdesc:a7cee60eb3a2149e2c0c8171d1948d9b4 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding output edge (overloaded function)  <a href="#a7cee60eb3a2149e2c0c8171d1948d9b4">More...</a><br /></td></tr>
<tr class="separator:a7cee60eb3a2149e2c0c8171d1948d9b4 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d52a58a00fb99c18ea4b4878d99f50f inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a8d52a58a00fb99c18ea4b4878d99f50f">add_edge</a> (OUT_EDGE_BUF &amp;x)</td></tr>
<tr class="memdesc:a8d52a58a00fb99c18ea4b4878d99f50f inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding multiple ouput edges  <a href="#a8d52a58a00fb99c18ea4b4878d99f50f">More...</a><br /></td></tr>
<tr class="separator:a8d52a58a00fb99c18ea4b4878d99f50f inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8fbad4bba036f22d32b8981490bc7479 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a8fbad4bba036f22d32b8981490bc7479">remove_edge</a> (IdType &amp;target)</td></tr>
<tr class="memdesc:a8fbad4bba036f22d32b8981490bc7479 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removing an output edge identified by target node.  <a href="#a8fbad4bba036f22d32b8981490bc7479">More...</a><br /></td></tr>
<tr class="separator:a8fbad4bba036f22d32b8981490bc7479 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64fb1198fff6fe1044b77c3605acf876 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a64fb1198fff6fe1044b77c3605acf876"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a64fb1198fff6fe1044b77c3605acf876">get_num_out_edges</a> ()</td></tr>
<tr class="memdesc:a64fb1198fff6fe1044b77c3605acf876 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the total number of output edges <br /></td></tr>
<tr class="separator:a64fb1198fff6fe1044b77c3605acf876 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab1579d784f577a894b15a5f24458911 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aab1579d784f577a894b15a5f24458911"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#aab1579d784f577a894b15a5f24458911">getNumDifferentNbr</a> ()</td></tr>
<tr class="memdesc:aab1579d784f577a894b15a5f24458911 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of neigbors excluding self (i.e., ignoring self cycles) <br /></td></tr>
<tr class="separator:aab1579d784f577a894b15a5f24458911 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bcc0c3d992719b29f3f12528d81900b inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a2bcc0c3d992719b29f3f12528d81900b">get_children</a> (vector&lt; IdType &gt; &amp;vectChildren)</td></tr>
<tr class="memdesc:a2bcc0c3d992719b29f3f12528d81900b inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the vertex id of all children  <a href="#a2bcc0c3d992719b29f3f12528d81900b">More...</a><br /></td></tr>
<tr class="separator:a2bcc0c3d992719b29f3f12528d81900b inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5fcc3ceabc778b7cbb3fdf0791be1403 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a5fcc3ceabc778b7cbb3fdf0791be1403">isConnected</a> (IdType node)</td></tr>
<tr class="memdesc:a5fcc3ceabc778b7cbb3fdf0791be1403 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if a given node is connected to the current node  <a href="#a5fcc3ceabc778b7cbb3fdf0791be1403">More...</a><br /></td></tr>
<tr class="separator:a5fcc3ceabc778b7cbb3fdf0791be1403 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5d0a19bade61bb0cb3a221f22286a8d inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af5d0a19bade61bb0cb3a221f22286a8d"></a>
DataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#af5d0a19bade61bb0cb3a221f22286a8d">get_value</a> ()</td></tr>
<tr class="memdesc:af5d0a19bade61bb0cb3a221f22286a8d inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the vertex data field <br /></td></tr>
<tr class="separator:af5d0a19bade61bb0cb3a221f22286a8d inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b4a6dabec3f6b9251490194ef977f45 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1b4a6dabec3f6b9251490194ef977f45"></a>
AlgDataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a1b4a6dabec3f6b9251490194ef977f45">getAlgData</a> ()</td></tr>
<tr class="memdesc:a1b4a6dabec3f6b9251490194ef977f45 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the algorithm data <br /></td></tr>
<tr class="separator:a1b4a6dabec3f6b9251490194ef977f45 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf41c6b7e523f7b09d1794b4e50161fc inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acf41c6b7e523f7b09d1794b4e50161fc"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#acf41c6b7e523f7b09d1794b4e50161fc">getId</a> ()</td></tr>
<tr class="memdesc:acf41c6b7e523f7b09d1794b4e50161fc inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the vertex id <br /></td></tr>
<tr class="separator:acf41c6b7e523f7b09d1794b4e50161fc inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d84fcd90980e82113bb99f1635b5921 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9d84fcd90980e82113bb99f1635b5921"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a9d84fcd90980e82113bb99f1635b5921">get_out_edge_iterator</a> ()</td></tr>
<tr class="memdesc:a9d84fcd90980e82113bb99f1635b5921 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to the start of the outEdges buffer <br /></td></tr>
<tr class="separator:a9d84fcd90980e82113bb99f1635b5921 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8b430cc4ba7c354e49753a648a9664c inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad8b430cc4ba7c354e49753a648a9664c"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#ad8b430cc4ba7c354e49753a648a9664c">get_end_out_edge_iterator</a> ()</td></tr>
<tr class="memdesc:ad8b430cc4ba7c354e49753a648a9664c inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to the last edge of the outEdges buffer <br /></td></tr>
<tr class="separator:ad8b430cc4ba7c354e49753a648a9664c inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a020a35d8d33cf7164b7e40c682915d61 inherit pub_methods_classvertex"><td class="memItemLeft" align="right" valign="top">OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a020a35d8d33cf7164b7e40c682915d61">get_edge</a> (ID_TYPE target)</td></tr>
<tr class="memdesc:a020a35d8d33cf7164b7e40c682915d61 inherit pub_methods_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to the output edge with a given target  <a href="#a020a35d8d33cf7164b7e40c682915d61">More...</a><br /></td></tr>
<tr class="separator:a020a35d8d33cf7164b7e40c682915d61 inherit pub_methods_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a42d96a975fbffe4000fb8cd46b5aa44b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a42d96a975fbffe4000fb8cd46b5aa44b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#a42d96a975fbffe4000fb8cd46b5aa44b">flagActive</a></td></tr>
<tr class="memdesc:a42d96a975fbffe4000fb8cd46b5aa44b"><td class="mdescLeft">&#160;</td><td class="mdescRight">active flag <br /></td></tr>
<tr class="separator:a42d96a975fbffe4000fb8cd46b5aa44b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classvertex"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classvertex')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classvertex.html">vertex&lt; DataType, AlgDataType, EdgeType, IdType &gt;</a></td></tr>
<tr class="memitem:acc60a3d4a79194de386251640bc8304c inherit pro_attribs_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acc60a3d4a79194de386251640bc8304c"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#acc60a3d4a79194de386251640bc8304c">id</a></td></tr>
<tr class="memdesc:acc60a3d4a79194de386251640bc8304c inherit pro_attribs_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">unique vertex ID <br /></td></tr>
<tr class="separator:acc60a3d4a79194de386251640bc8304c inherit pro_attribs_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7d3f791514c0c4fafbe2f8f671ffae8 inherit pro_attribs_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad7d3f791514c0c4fafbe2f8f671ffae8"></a>
DataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#ad7d3f791514c0c4fafbe2f8f671ffae8">vertexData</a></td></tr>
<tr class="memdesc:ad7d3f791514c0c4fafbe2f8f671ffae8 inherit pro_attribs_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">associated generic data <br /></td></tr>
<tr class="separator:ad7d3f791514c0c4fafbe2f8f671ffae8 inherit pro_attribs_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a140eb4cb64824b855f7c0a355861c421 inherit pro_attribs_classvertex"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a140eb4cb64824b855f7c0a355861c421"></a>
AlgDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#a140eb4cb64824b855f7c0a355861c421">algData</a></td></tr>
<tr class="memdesc:a140eb4cb64824b855f7c0a355861c421 inherit pro_attribs_classvertex"><td class="mdescLeft">&#160;</td><td class="mdescRight">Algorithm-specific data. <br /></td></tr>
<tr class="separator:a140eb4cb64824b855f7c0a355861c421 inherit pro_attribs_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae937679f3315f6494e0d21692d753939 inherit pro_attribs_classvertex"><td class="memItemLeft" align="right" valign="top">OUT_EDGE_BUF&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classvertex.html#ae937679f3315f6494e0d21692d753939">outEdges</a></td></tr>
<tr class="separator:ae937679f3315f6494e0d21692d753939 inherit pro_attribs_classvertex"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr class="memitem:aa62d1bdeb2a5b1821ff14d7ac2104010"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa62d1bdeb2a5b1821ff14d7ac2104010"></a>
static <a class="el" href="classAggInfo.html">AGGREGATE_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#aa62d1bdeb2a5b1821ff14d7ac2104010">aggregateInfoPtr</a></td></tr>
<tr class="memdesc:aa62d1bdeb2a5b1821ff14d7ac2104010"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the aggregate information <br /></td></tr>
<tr class="separator:aa62d1bdeb2a5b1821ff14d7ac2104010"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1b0537605558932e0d0b37c943a5dd8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae1b0537605558932e0d0b37c943a5dd8"></a>
static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#ae1b0537605558932e0d0b37c943a5dd8">activeWithNoMessage</a></td></tr>
<tr class="memdesc:ae1b0537605558932e0d0b37c943a5dd8"><td class="mdescLeft">&#160;</td><td class="mdescRight">a flag when true the vertex is processed even with no message, if false it is processed only if there are messages <br /></td></tr>
<tr class="separator:ae1b0537605558932e0d0b37c943a5dd8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4396136748432ddfd81318044b419010"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4396136748432ddfd81318044b419010"></a>
static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexP.html#a4396136748432ddfd81318044b419010">reactivateFlag</a></td></tr>
<tr class="memdesc:a4396136748432ddfd81318044b419010"><td class="mdescLeft">&#160;</td><td class="mdescRight">a flag when true the vertex can be reactivated by new messages, otherwise it never wake up once becomes inactive <br /></td></tr>
<tr class="separator:a4396136748432ddfd81318044b419010"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename InitType, typename IdType = uint32, typename MessageType = DblMessage&gt;<br />
class VertexP&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;</h3>

<p>core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class and add messaging capabilities This class is inherited by customized classes for different graph algorithms. It is a template class that is parameterized by the following parameters </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DataType</td><td>the vertex data field, </td></tr>
    <tr><td class="paramname">AlgDataType</td><td>the algorithm data field, </td></tr>
    <tr><td class="paramname">EdgeType</td><td>the edge type, </td></tr>
    <tr><td class="paramname">InitType</td><td>the type of initial data for the graph algorithm, </td></tr>
    <tr><td class="paramname">IdType</td><td>the type of id for the vertices </td></tr>
    <tr><td class="paramname">the</td><td>pregel message type. </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a073ad0f9e1d21754499bde31ad5b4e8f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename InitType, typename IdType = uint32, typename MessageType = DblMessage&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classVertexP.html">VertexP</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::<a class="el" href="classVertexP.html">VertexP</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>noMessageFlag</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>inFlagReactivate</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>constructor setting parameters and callign the constructor of the base class </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>vertex id </td></tr>
    <tr><td class="paramname">noMessageFlag</td><td>flag to set activeWithNoMessage </td></tr>
    <tr><td class="paramname">inFlagReactivate</td><td>flag to set reactivateFlag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aa7ed5eb0c1d2c351bdc086d42a2684c7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename InitType, typename IdType = uint32, typename MessageType = DblMessage&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual uint32 <a class="el" href="classVertexP.html">VertexP</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::compute </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_BUF_TYPE *&#160;</td>
          <td class="paramname"><em>pIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LOCAL_MESSAGE_BUF *&#160;</td>
          <td class="paramname"><em>pOut</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>numMessages</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>virtual core compute function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pIn</td><td>pointer to the input message buffer </td></tr>
    <tr><td class="paramname">pOut</td><td>pointer to the output message buffer </td></tr>
    <tr><td class="paramname">numMessages</td><td>the number of input data messages </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of output data messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad9caab616ae90c7f0c6af36953f3f441"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename InitType, typename IdType = uint32, typename MessageType = DblMessage&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual uint32 <a class="el" href="classVertexP.html">VertexP</a>&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;::init </td>
          <td>(</td>
          <td class="paramtype">INIT_TYPE *&#160;</td>
          <td class="paramname"><em>initParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LOCAL_MESSAGE_BUF *&#160;</td>
          <td class="paramname"><em>pOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>virtual core init function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">initParams</td><td>pointer to the initialization parameters </td></tr>
    <tr><td class="paramname">pOut</td><td>pointer to the output message buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of output data messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/standard/containers/<a class="el" href="tiglContainersPregelVertex_8hpp_source.html">tiglContainersPregelVertex.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
